#include "include.h"

extern float *zbuffer;




#include "include.h"


#define TICK_TIMER 1


extern "C" {
	int init();
	int render(char *data, int width, int height, int time);
	void clear(unsigned char color);
	void swap();
	void put_pixel(int x, int y, char color);
	extern char *vram;
	extern int SCREEN_WIDTH;
	extern int SCREEN_HEIGHT;
}

texinfo_t texinfo;

float *zbuffer = NULL;

int index_buffer[] = { 0,1,2,3,4,5,6,7,8,9,10, 11,12,13,14,15,16,17,18,19,20 ,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35};


vec4 vert[36] =
{
	// Front face
	vec4(-0.5f, 0.5f, 0.5f, 1.0f), //3
	vec4(0.5f, -0.5f, 0.5f, 1.0f), //2
	vec4(0.5f, 0.5f, 0.5f, 1.0f),  //1

	vec4(-0.5f, -0.5f, 0.5f, 1.0f), //4
	vec4(0.5f, -0.5f, 0.5f, 1.0f),  //2
	vec4(-0.5f, 0.5f, 0.5f, 1.0f), //3

	// Back face
	vec4(0.5f, 0.5f, -0.5f, 1.0f),		//3
	vec4(-0.5f, -0.5f, -0.5f, 1.0f),	//2
	vec4(-0.5f, 0.5f, -0.5f, 1.0f),		//1

	vec4(0.5f, -0.5f, -0.5f, 1.0f),		//4
	vec4(-0.5f, -0.5f, -0.5f, 1.0f),	//2
	vec4(0.5f, 0.5f, -0.5f, 1.0f),		//3

	// Left face
	vec4(-0.5f, 0.5f, -0.5f, 1.0f),		//3
	vec4(-0.5f, -0.5f, 0.5f, 1.0f),		//2
	vec4(-0.5f, 0.5f, 0.5f, 1.0f),		//1

	vec4(-0.5f, -0.5f, -0.5f, 1.0f),	//4
	vec4(-0.5f, -0.5f, 0.5f, 1.0f),		//2
	vec4(-0.5f, 0.5f, -0.5f, 1.0f),		//3

	// Right face
	vec4(0.5f, 0.5f, 0.5f, 1.0f),		//3
	vec4(0.5f, -0.5f, -0.5f, 1.0f),		//2
	vec4(0.5f, 0.5f, -0.5f, 1.0f),		//1

	vec4(0.5f, -0.5f, 0.5f, 1.0f),		//4
	vec4(0.5f, -0.5f, -0.5f, 1.0f),		//2
	vec4(0.5f, 0.5f, 0.5f, 1.0f),		//3

	// Top face
	vec4(-0.5f, 0.5f, 0.5f, 1.0f),		//3
	vec4(0.5f, 0.5f, -0.5f, 1.0f),		//2
	vec4(-0.5f, 0.5f, -0.5f, 1.0f),		//1

	vec4(0.5f, 0.5f, 0.5f, 1.0f),		//4
	vec4(0.5f, 0.5f, -0.5f, 1.0f),		//2
	vec4(-0.5f, 0.5f, 0.5f, 1.0f),		//3

	// Bottom face
	vec4(0.5f, -0.5f, 0.5f, 1.0f),		//3
	vec4(-0.5f, -0.5f, -0.5f, 1.0f),	//2
	vec4(0.5f, -0.5f, -0.5f, 1.0f),		//1

	vec4(-0.5f, -0.5f, 0.5f, 1.0f),		//4
	vec4(-0.5f, -0.5f, -0.5f, 1.0f),	//2
	vec4(0.5f, -0.5f, 0.5f, 1.0f)		//3
};

vec2 texcord[36] =
{
	// Front face
	vec2(0.0f, 0.0f),			//2
	vec2(0.0f, -1.0f),			//1
	vec2(-1.0f, -1.0f),			//3

	vec2(0.0f, 0.0f),			//2
	vec2(-1.0f, -1.0f),			//3
	vec2(-1.0f, 0.0f),			//4


	// Back face
	vec2(0.0f, 0.0f),			//2
	vec2(0.0f, 1.0f),			//1
	vec2(1.0f, 1.0f),			//3

	vec2(0.0f, 0.0f),			//2
	vec2(1.0f, 1.0f),			//3
	vec2(1.0f, 0.0f),			//4

	// Left face
	vec2(0.0f, -1.0f),			//1
	vec2(0.0f, 0.0f),			//2
	vec2(-1.0f, -1.0f),			//3

	vec2(0.0f, 0.0f),			//2
	vec2(-1.0f, 0.0f),			//4
	vec2(-1.0f, -1.0f),			//3

	// Right face
	vec2(0.0f, 1.0f),			//1
	vec2(0.0f, 0.0f),			//2
	vec2(1.0f, 1.0f),			//3

	vec2(0.0f, 0.0f),			//2
	vec2(1.0f, 0.0f),			//4
	vec2(1.0f, 1.0f),			//3

	// Top face
	vec2(0.0f, 1.0f),			//1
	vec2(0.0f, 0.0f),			//2
	vec2(1.0f, 1.0f),			//3

	vec2(0.0f, 0.0f),			//2
	vec2(1.0f, 0.0f),			//4
	vec2(1.0f, 1.0f),			//3

	// Bottom face
	vec2(0.0f, 1.0f),			//1
	vec2(0.0f, 0.0f),			//2
	vec2(1.0f, 1.0f),			//3

	vec2(0.0f, 0.0f),			//2
	vec2(1.0f, 0.0f),			//4
	vec2(1.0f, 1.0f),			//3
};



int init()
{
	int tex_width = 256;
	int tex_height = 256;

	// alocate frame buffers
        vram = (char *)malloc(SCREEN_WIDTH * SCREEN_HEIGHT);
        if (vram == NULL)
        {
            printf("Unable to allocate video buffer\n");
            return -1;
        }
	printf("Allocated %dx%d frame buffer\n", SCREEN_WIDTH, SCREEN_HEIGHT);

	// allocate z buffer
	zbuffer = (float *)malloc(SCREEN_WIDTH * SCREEN_HEIGHT * 4);
        if (zbuffer == NULL)
        {
            printf("Unable to allocate z buffer\n");
            return -1;
        }
	printf("Allocated %dx%d z buffer\n", SCREEN_WIDTH, SCREEN_HEIGHT);


	// generate texture bitmap
	texinfo.data = new char[tex_width * tex_height];
	if (texinfo.data == NULL)
        {
            printf("Unable to allocate texture data\n");
            return -1;
        }

	printf("Allocated %dx%d texture\n", tex_width, tex_height);


	texinfo.width = tex_width;
	texinfo.height = tex_height;


	// populate texture checkerboard pattern
	int checksize = 8;
	for (int y = 0; y < tex_width; y++)
	{
		for (int x = 0; x < tex_height; x++)
		{
			int total = floor(x / (float)tex_width * checksize) +
				floor(y / (float)tex_height * checksize);
			bool isEven = total % 2 == 0;

			if (isEven)
				texinfo.data[x + y * tex_width] = 128;
			else
				texinfo.data[x + y * tex_width] = 64;

		}
	}
	return 0;
}

void rotate_vector(float rad, vec3 &vec, vec3 &axis)
{
	matrix3	m;
	float	sinVal, cosVal, minusVal;

	sinVal = (float)fsin(rad);
	cosVal = (float)fcos(rad);
	minusVal = 1.0f - cosVal;

	m.m[0] = cosVal + minusVal * axis.x * axis.x;
	m.m[1] = minusVal * axis.x * axis.y - sinVal * axis.z;
	m.m[2] = minusVal * axis.x * axis.z + sinVal * axis.y;

	m.m[3] = minusVal * axis.y * axis.x + sinVal * axis.z;
	m.m[4] = cosVal + minusVal * axis.y * axis.y;
	m.m[5] = minusVal * axis.y * axis.z - sinVal * axis.x;

	m.m[6] = minusVal * axis.z * axis.x - sinVal * axis.y;
	m.m[7] = minusVal * axis.z * axis.y + sinVal * axis.x;
	m.m[8] = cosVal + minusVal * axis.z * axis.z;

	vec = m * vec;
}


int render(char *data, int width, int height, int time)
{
        int j = 0;
        int x = 0;
        int y = 0;

//	printf("Clearing frame buffer\n");
        clear(0);



//	printf("Performing transforms\n");
	matrix4 transformation;
	matrix4 projection;
	matrix4 mvp;
	vec4 box2d[36];

	vec3 pos(1.0f, 1.0f, -0.5f);


	vec3 forward = vec3(0.0f, 0.0, 1.0f);
	vec3 up = vec3(0.0f, 1.0f, 0.0f);
	vec3 vup = vec3(0.0f, 1.0f, 0.0f);
	vec3 right;

	// Left / Right
	rotate_vector(time * 0.01f, forward, vup );
	rotate_vector(time * 0.01f, up, vup);
	forward.normalize();
	up.normalize();

	// Up / Down
	right = vec3::crossproduct(up, forward);
	right.normalize();

	rotate_vector(time * 0.01f, forward, right);
	rotate_vector(time * 0.01f, up, right);
	forward.normalize();
	up.normalize();


	transformation.m[0] = right.x;
	transformation.m[1] = right.y;
	transformation.m[2] = right.z;
	transformation.m[3] = 0.0f;

	transformation.m[4] = up.x;
	transformation.m[5] = up.y;
	transformation.m[6] = up.z;
	transformation.m[7] = 0.0f;

	transformation.m[8] = forward.x;
	transformation.m[9] = forward.y;
	transformation.m[10] = forward.z;
	transformation.m[11] = 0.0f;

	transformation.m[12] = 0.0f;
	transformation.m[13] = 0.0f;
	transformation.m[14] = 0.0f;
	transformation.m[15] = 1.0f;

	// typical opengl style projection
	projection.perspective(90.0f, 1.0f, 1.0, 2001.0f, false);

	mvp = transformation;

	//rotate about origin
	for(int i = 0; i < 36; i++)
	{
		box2d[i] = mvp * vert[i];
	}

	transformation.m[0] = 1.0f;
	transformation.m[1] = 0.0f;
	transformation.m[2] = 0.0f;
	transformation.m[3] = 0.0f;

	transformation.m[4] = 0.0f;
	transformation.m[5] = 1.0f;
	transformation.m[6] = 0.0f;
	transformation.m[7] = 0.0f;

	transformation.m[8] = 0.0f;
	transformation.m[9] = 0.0f;
	transformation.m[10] = 1.0f;
	transformation.m[11] = 0.0f;

	transformation.m[12] = pos.x;
	transformation.m[13] = pos.y;
	transformation.m[14] = pos.z;
	transformation.m[15] = 1.0f;

	// make things bigger
	transformation = transformation * (height / 2.0f);

	mvp = transformation * projection;

	//translate a little, scale and project
	for(int i = 0; i < 36; i++)
	{
		box2d[i] = mvp * box2d[i];
	}


//	printf("Rendering triangle\n");
	int i = 0;
	for (i = 0; i < 36; i+=3)
	{
//		printf("Loop %d\n", i);

		barycentric_triangle_tex(data, zbuffer, width, height, &texinfo,
			box2d[index_buffer[i]].x, box2d[index_buffer[i]].y, box2d[index_buffer[i]].z, 
			box2d[index_buffer[i+1]].x, box2d[index_buffer[i+1]].y, box2d[index_buffer[i + 1]].z, 
			box2d[index_buffer[i+2]].x, box2d[index_buffer[i+2]].y, box2d[index_buffer[i + 2]].z, 
			texcord[index_buffer[i]].x, texcord[index_buffer[i]].y,
			texcord[index_buffer[i+1]].x, texcord[index_buffer[i+1]].y,
			texcord[index_buffer[i+2]].x, texcord[index_buffer[i+2]].y);
	}

//	printf("Clearing z buffer\n");
	memset(zbuffer, 0, width * height * 4);


        swap();
	return 0;
}



void draw_pixel(char *pixels, float *zbuffer, int width, int height, int x, int y, int z, unsigned char color)
{
	if (width < 0 || height < 0)
		return;
	if (x >= width || y >= height)
		return;

	if (x < 0 || y < 0)
		return;


	if (zbuffer[x + y * width] > z)
	{
		put_pixel(x,y,color);
		zbuffer[x + y * width] = z;
	}
}


void barycentric_triangle_tex(char *pixels, float *zbuffer, int width, int height, texinfo_t *texture,
	int x1, int y1, float z1,
	int x2, int y2, float z2,
	int x3, int y3, float z3,
	float u1, float v1,
	float u2, float v2,
	float u3, float v3)
{
	int max_x = MAX(x1, MAX(x2, x3));
	int min_x = MIN(x1, MIN(x2, x3));
	int max_y = MAX(y1, MAX(y2, y3));
	int min_y = MIN(y1, MIN(y2, y3));

	// triangle spanning vectors
	int vspan1x = (x2 - x1);
	int vspan1y = (y2 - y1);

	int vspan2x = (x3 - x1);
	int vspan2y = (y3 - y1);

	for (int y = min_y; y <= max_y; y++)
	{
		for (int x = min_x; x <= max_x; x++)
		{
			// center xy over origin point
			int qx = (x - x1);
			int qy = (y - y1);

			// area of parallelogram formed by spanning vectors
			int area_denom = det(vspan1x, vspan1y, vspan2x, vspan2y);

			// zero area triangle
			if (area_denom == 0)
				return;

			// barycentric coords (s,t,1-s-t)
			float s = (float)det(qx, qy, vspan2x, vspan2y) / area_denom;
			float t = (float)det(vspan1x, vspan1y, qx, qy) / area_denom;

			// if inside triangle
			if ((s >= 0) && (t >= 0) && (s + t <= 1))
			{
				float u = s * u2 + t * u3 + (1 - s - t) * u1;
				float v = s * v2 + t * v3 + (1 - s - t) * v1;
				float z = s * z2 + t * z3 + (1 - s - t) * z1;

				int ux;
				int vy;
				if (u > 0)
				{
					ux = ((texture->width - 1) * u);
					ux = ux % (texture->width - 1);
				}
				else
				{
					ux = ((texture->width - 1) * -u);
					ux = ux % (texture->width - 1);
					ux = texture->width - 1 - ux;
				}

				if (v > 0)
				{
					vy = ((texture->height - 1) * v);
					vy = vy % (texture->height - 1);
				}
				else
				{
					vy = ((texture->height - 1) * -v);
					vy = vy % (texture->height - 1);
					vy = texture->height - 1 - vy;
				}

				int index = ux + vy * (texture->width - 1);

				if (index <  0 || index >= texture->width * texture->height)
					index = 0;
				//(int)(ux + vy * texture->width)
				draw_pixel(pixels, zbuffer, width, height, x, y, z, texture->data[index]);
			}
		}
	}
}
